/*
  *  
  *	see tcpha_be.c for infoes about TCPHA
  *
  */
  
#include "tcpha_be.h"

static unsigned int noarp_infilter (unsigned int hook,
                                    struct sk_buff **pskb,
                                    const struct net_device *indev,
                                    const struct net_device *outdev,
                                    int (*okfn)(struct sk_buff *))
   {
   struct sk_buff * skb   = *pskb;
   struct ethhdr  * peth  = skb->mac.ethernet;
   struct arphdr  * parp  = skb->nh.arph;
   __u8 * pch   = ((__u8 *)skb->nh.arph) + sizeof (struct arphdr);
   __u32 src,dst;
   
   int apiRet = NF_ACCEPT;


   if ((peth == NULL) ||
       (peth->h_proto != __constant_htons (ETH_P_ARP)) ||
       (parp->ar_hln  != (unsigned char) 6) ||
       (parp->ar_pln  != (unsigned char) 4) ||
       (parp->ar_op   != __constant_htons (ARPOP_REQUEST)))
      {
          return apiRet;
      }
   
   src=*((uint32_t*)(pch + parp->ar_hln));
   dst=*((uint32_t*)(pch + parp->ar_hln + parp->ar_pln + parp->ar_hln));

   if (dst==tbs.conf.vaddr)
   	apiRet=NF_DROP;

   if (src==tbs.conf.vaddr)
   	*((uint32_t*)(pch + parp->ar_hln))=tbs.conf.uaddr;

   return apiRet;
   }

/****************************************************************************/
/* Output ARP Filtering
*****************************************************************************/
static unsigned int noarp_outfilter (unsigned int hook,
                                     struct sk_buff **pskb,
                                     const struct net_device *indev,
                                     const struct net_device *outdev,
                                     int (*okfn)(struct sk_buff *))
   {
   struct sk_buff * skb   = *pskb;
   struct arphdr  * parp  = skb->nh.arph;
   __u8 * pch   = ((__u8 *)skb->nh.arph) + sizeof (struct arphdr);
   __u32 src,dst;
   int apiRet = NF_ACCEPT;

   if ((parp->ar_hln  != (unsigned char) 6) ||
       (parp->ar_pln  != (unsigned char) 4))
      {
      return apiRet;
      }
   src=*((uint32_t*)(pch + parp->ar_hln));
   dst=*((uint32_t*)(pch + parp->ar_hln + parp->ar_pln + parp->ar_hln));

   if (dst==tbs.conf.uaddr)
   	{
          *((uint32_t*)(pch + parp->ar_hln + parp->ar_pln + parp->ar_hln))=tbs.conf.vaddr;
          return apiRet;
   	}

   if (parp->ar_op == __constant_htons (ARPOP_REPLY))
   {
        if (src==tbs.conf.vaddr)
        	apiRet=NF_DROP;
   }

   else if (parp->ar_op == __constant_htons (ARPOP_REQUEST))
      {
           if (src==tbs.conf.vaddr)
           	*((uint32_t*)(pch + parp->ar_hln)) = tbs.conf.raddr;
      }
   return apiRet;
   }

/****************************************************************************/
/* Hooks Table
*****************************************************************************/
struct nf_hook_ops noarp_nf_ops_in =
   {{ NULL, NULL }, noarp_infilter, NF_ARP, NF_ARP_IN, 0};
struct nf_hook_ops noarp_nf_ops_out =
   {{ NULL, NULL }, noarp_outfilter, NF_ARP, NF_ARP_OUT, 0};
